/*
 * Copyright 2013 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef JOYSTICKDRIVER_H
#define JOYSTICKDRIVER_H

#include "Driver.h"
#include "SDL.h"

enum JoyType
{
	JOY_UNKNOWN,
	JOY_AXIS,
	JOY_HAT,
	JOY_BUTTON
};

struct JoyInput
{
	int type;
	int index;
	int state;
};

const int AXIS_THRESHOLD = 10000;

class JoystickDriver : public Driver
{
public:
	JoystickDriver(const std::string& name, SDL_Joystick* joy);
	virtual int drive(int carId, const Track& track);
	virtual bool setControl(const SDL_Event& event, int control);
	virtual std::string getControlName(int control) const;
	virtual void save(std::ostream&) const;
	virtual void load(std::istream&);
private:
	std::string name;
	SDL_Joystick* joy;
	JoyInput inputs[4];
};

#endif
